﻿using System;
using System.Collections.Generic;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using SquishTest;

namespace SquishTestsProject
{
    [TestClass]
    public class SquishTests
    {
        static string squishPackage;
        static string host;
        static string port;
        static string reportDir;
        static string testcenterBaseURL;
        static string uploadToken;
        static string project;
        static string batchName;
        static Dictionnary<string, string> labels;

        [ClassInitialize]
        static public void ClassInitialize(TestContext testContext)
        {
            squishPackage = "D:\\Squish\\Windows\\squish-6.5.0-windows";
            host = "127.0.0.1";
            port = "8888";
            reportDir = "D:\\tmp\\res\\" + DateTime.Now.ToString("yyyy-MM-dd-HH_mm_ss_fff");

            testcenterBaseURL = "http://mytestcenter:8800";

            uploadToken = "Mytoken";

            project = "MyProject";

            batchName = null;

            labels = new Dictionnary<string, string>();
            labels.Add("OS", "Windows");
        }

        [TestMethod]
        public void TestSuite1()
        {
            string testSuite = "D:\\Squish\\Windows\\squish-6.5.0-windows\\examples\\win\\Addressbook\\suite_py";
            SquishRun squishRun = new SquishRun(squishPackage, testSuite);
            squishRun.HtmlReport(reportDir);
            squishRun.Start();
            Assert.IsTrue(squishRun.ExecutionSuccessful, "Test execution failed.\n" + squishRun.RunnerErrorOutput);
        }

        [TestMethod]
        public void TestSuite2()
        {
            string testSuite = "D:\\Squish\\Windows\\squish-6.5.0-windows\\examples\\win\\Addressbook\\suite_py";
            SquishRun squishRun = new SquishRun(squishPackage, testSuite, host, port);
            squishRun.HtmlReport(reportDir);
            squishRun.Start();
            Assert.IsTrue(squishRun.ExecutionSuccessful, "Test execution failed.\n" + squishRun.RunnerErrorOutput);
        }

        [TestMethod]
        public void TestSuite3()
        {
            string testSuite = "D:\\Squish\\Windows\\squish-6.5.0-windows\\examples\\win\\Addressbook\\suite_py";
            string[] testCases = new string[] { "tst_adding" };
            SquishRun squishRun = new SquishRun(squishPackage, testSuite, testCases);
            squishRun.HtmlReport(reportDir);
            squishRun.Start();
            Assert.IsTrue(squishRun.ExecutionSuccessful, "Test execution failed.\n" + squishRun.RunnerErrorOutput);
        }

        [TestMethod]
        public void TestSuite4()
        {
            string testSuite = "D:\\Squish\\Windows\\squish-6.5.0-windows\\examples\\win\\Addressbook\\suite_py";
            SquishRun squishRun = new SquishRun(squishPackage, testSuite);
            squishRun.TestcenterReport(testcenterBaseURL, uploadToken, project, batchName, labels);
            squishRun.Start();
            Console.WriteLine("Link to report is: " + testcenterBaseURL + "/Testcenter/explore?report=" + squishRun.TestcenterImportID);
            Assert.IsTrue(squishRun.ExecutionSuccessful, "Test execution failed.\n" + squishRun.RunnerErrorOutput);
        }
    }
}